#pragma once

#include "NetUtils.h"

#include <ehs/Serializer.h>

namespace ehs
{
	class NetFrag
	{
	private:
		Header header;
		Serializer<UInt_64>* data;
		UInt_64 size;

	public:
		~NetFrag();

		NetFrag();

		NetFrag(const Header &header, const Serializer<UInt_64> &payload);

        NetFrag(const Header &header, UInt_64 size);

		NetFrag(NetFrag &&frags) noexcept;

		NetFrag(const NetFrag &frags);

		NetFrag &operator=(NetFrag &&frags) noexcept;

		NetFrag &operator=(const NetFrag &frags);

		operator Serializer<UInt_64> *() const;

		Header GetHeader() const;

		UInt_64 Size() const;

		bool IsComplete() const;

		Packet Combine() const;
	};
}
